// Copyright (c) 2006-2007 Virtual Ubiquity, Inc. All rights reserved.
function doLoad() {
	// hide non-top level nav items
	var ni3s = getElementsByClass('navItem3', document, 'div');
	for (var ni = 0; ni < ni3s.length; ni++) {
		ni3s[ni].style.display = 'none';
	}
	var ni2s = getElementsByClass('navItem2', document, 'div');
	for (var ni = 0; ni < ni2s.length; ni++) {
		ni2s[ni].style.display = 'none';
	}
	window.onscroll = doScroll;
	setNavPos();
}


function doResize() {

}

function doScroll(e) {
	setNavPos();
}

function setNavPos() {
	nc = getElement('navCell');
	
	var yScrollPos;
	if (window.innerHeight)
	{
		  yScrollPos = window.pageYOffset;
	}
	else if (document.documentElement && document.documentElement.scrollTop)
	{
		yScrollPos = document.documentElement.scrollTop;
	}
	else if (document.body)
	{
		  yScrollPos = document.body.scrollTop;
	}
	nc.style.paddingTop = yScrollPos + 'px';
}

function toggleChildNavItems(t) {
	//if (!e) var e = window.event;

//	var t;
//	if (e.target) t = e.target;
//	else if (e.srcElement) t = e.srcElement;
//	alert(t.tagName);
	var ci = t.parentNode;
	var clickItemLevel = getItemLevel(ci);
	
	var showing = false;	// flag - are we showing or hiding the children
	var nis = getElementsByClass('navItem' + (clickItemLevel + 1), ci, 'div');
	for (var ni = 0; ni < nis.length; ni++) {
		if (nis[ni].style.display == 'none') {
			nis[ni].style.display = 'block';
			showing = true;
		}
		else {
			nis[ni].style.display = 'none';		
		}
	}
	
	if (showing) {	// hide the children of my siblings
		var cip = ci.parentNode;
		
		var sibs = getElementsByClass('navItem' + (clickItemLevel), cip, 'div');
		for (var si=0; si <sibs.length; si++) {
			if (sibs[si] != ci) {
				var snis = getElementsByClass('navItem' + (clickItemLevel + 1), sibs[si], 'div');
				for (var sni = 0; sni < snis.length; sni++) {
					if (snis[sni].style.display == 'block') {
						snis[sni].style.display = 'none';		
					}
				}
			}
		}
	}
}

function getItemLevel(t) {
	return parseInt(t.className.charAt(t.className.length - 1));
}

function standardOver(t) {
	t.className += " " + t.className + "Over";
}

function standardOut(t) {
	var classNames = t.className.split(" ");
	t.className = classNames[0];
}

function getElement(id) {
	var e = document.getElementById(id);
	
	if (!e) alert('bad element id: ', id);
	
	return e;
}

function getElementsByClass(searchClass,node,tag) {
	var classElements = new Array();
	if ( node == null )
		node = document;
	if ( tag == null )
		tag = '*';
	var els = node.getElementsByTagName(tag);
	var elsLen = els.length;
	var pattern = new RegExp("(^|\\s)"+searchClass+"(\\s|$)");
	for (i = 0, j = 0; i < elsLen; i++) {
		if ( pattern.test(els[i].className) ) {
			classElements[j] = els[i];
			j++;
		}
	}
	return classElements;
}