var gbProjectLoaded=false;
function putDataXML(xmlDoc,sDocPath)
{
	if(!gbProjectLoaded)
	{
		putDataXMLProj(xmlDoc , sDocPath);
		if(gnChecked > 0)	
			checkRemoteProject();
	}
	else
	{
		if(gnLoadFts==1)
		{
			var node=xmlDoc.lastChild;
			if(node)
			{
				var oChild=node.firstChild;
				var aFCD=new Array();
				var aFTCD=new Array();
				while(oChild)
				{
					if(oChild.nodeName=="chunkinfo")
					{
						var sURL=oChild.getAttribute("url");
						var sFirst=oChild.getAttribute("first");
						var sLast=oChild.getAttribute("last");
						if(sURL&&sFirst&&sLast)
						{
							item=new Object();
							item.sStartKey=sFirst;
							item.sEndKey=sLast;
							item.sFileName=sURL;
							aFCD[aFCD.length]=item;
						}
					}
					else if(oChild.nodeName=="tchunkinfo")
					{
						var sURL=oChild.getAttribute("url");
						var nB=parseInt(oChild.getAttribute("first"));
						var nE=parseInt(oChild.getAttribute("last"));
						if(sURL&&sFirst&&sLast)
						{
							item=new Object();
							item.nBegin=nB;
							item.nEnd=nE;
							item.sFileName=sURL;
							aFTCD[aFTCD.length]=item;
						}
	
					}
					oChild=oChild.nextSibling;
				}
				ftsReady(aFCD,aFTCD);
			}
		}
		else if(gnLoadFts==3)
		{
			var node=xmlDoc.lastChild;
			if(node)
			{
				var oChild=node.firstChild;
				var aTopics=new Array();
				while(oChild)
				{
					if(oChild.nodeName=="topic")
					{
						var name=oChild.getAttribute("name");
						var sURL=oChild.getAttribute("url");
						var sContext=oChild.getAttribute("context");
						if(name&&name.length>0&&sURL)
						{
							var topic=new Object();
							topic.sTopicTitle=name;
							topic.sTopicURL=sURL;
							topic.sTopicContext = sContext;
							aTopics[aTopics.length]=topic;
						}
					}
					oChild=oChild.nextSibling;
				}
				putFtsTData(aTopics);
			}
		}
		else if(gnLoadFts==2)
		{
			var node=xmlDoc.lastChild;
			if(node)
			{
				var oChild=node.firstChild;
				var aFtsContents=new Array();
				while(oChild)
				{
					if(oChild.nodeName=="key")
					{
						var name=oChild.getAttribute("name");
						if(name&&name.length>0)
						{
							var item=new Object();
							item.sItemName=name;
							aFtsContents[aFtsContents.length]=item;
							var oChildChild=oChild.firstChild;
							while(oChildChild)
							{
								if(oChildChild.nodeName=="#text")
								{
									var sIDs=oChildChild.nodeValue;
									if(sIDs)
									{
										var nBPos=0;
										do
										{
											var nPos=sIDs.indexOf(",",nBPos);
											var sID=null;
											if(nPos!=-1)
												sID=sIDs.substring(nBPos,nPos);
											else
												sID=sIDs.substring(nBPos);
	
											if(sID)
											{
												var id=parseInt(sID);
												if(!isNaN(id))
												{
													if(!item.aTopics)
														item.aTopics=new Array();
													item.aTopics[item.aTopics.length]=id;
												}
											}
											nBPos=nPos+1;
										}while(nBPos!=0&&nBPos<sIDs.length);
									}
								}
								oChildChild=oChildChild.nextSibling;
							}
						}
					}
					oChild=oChild.nextSibling;
				}
				putFtsWData(aFtsContents);
			}
		}
	}
}


function window_OnLoad()
{
	addProject(false, "whproj.xml", "whproj.htm");
	window_OnLoad1();
	if(gsBgImage&&gsBgImage.length>0)
	{
		document.body.background=gsBgImage;
	}
	if(gsBgColor&&gsBgColor.length>0)
	{
		document.body.bgColor=gsBgColor;
	}
	writeResultDiv();
	loadFts();
}

function loadFts()
{
	var oProj=new Object();
	oProj.aProj=gaProj;
	oProj.bXML=gbXML;
	gbReady=true;
	var aProj=oProj.aProj;
	gbXML=oProj.bXML;
	if(aProj.length>0)
	{
		var sLangId=aProj[0].sLangId;
		for(var i=0;i<aProj.length;i++)
		{
			if(aProj[i].sFts&&aProj[i].sLangId==sLangId)
			{
				addFtsInfo(aProj[i].sPPath,aProj[i].sDPath,aProj[i].sFts);
			}
		}
	}
	loadFD();
}

function loadFD()
{
	if(gnCLF<gaData.length)
	{
		gnLoadFts=1;
		loadData2(gaData[gnCLF].sPPath+gaData[gnCLF].sDPath+gaData[gnCLF].sFtsFile);
	}
	else 
	{
		gsSK = GetSearchText();
		findFTSKey();
	}
}

function checkAgain()
{
	gsCheckKey = "";
	gnIndexNum = 0;
	gsSK=gsSK2;
	gsSK2=null;
	if(gsSK!=null)
		findFTSKey();
}

function displayTopics()
{
	var sHTML="";
	var sLine="";
	var sHighlight = "?searchhighlightTextStringRoboHelp=" + GetSearchText();
	if(gaTI.length > 0)
	{
		sLine += "<ul>";
		for(var i=0;i<gaTI.length;i++){
			sLine+="<li><p style=\"line-height: 170%\"><a href='"+gaTI[i].sTopicURL+sHighlight+"'><b>"+_textToHtml(gaTI[i].sTopicTitle)+"</b></a><br>";
			if(gaTI[i].sTopicContext != null)
			{
				sLine+=  _textToHtml_nonbsp(gaTI[i].sTopicContext) ;
			}
			sLine += "</p>";
			if(i>>4<<4==i)
			{
				sHTML+=sLine;
				sLine="";
			}
		}
		sLine += "</ul>";
	}
	
	if(sLine.length>0)
		sHTML+=sLine;

	if(sHTML.length==0)
		sHTML="<br><p>No Search Results</p>"
	else
		sHTML="<dl>"+sHTML+"</dl>";

	var resultDiv=getElement(gsResultDivID);
	if(resultDiv)
		resultDiv.innerHTML=sHTML;
}

function putFtsTData(aTopics)
{
	endLoading();
	var oCTF=goCTF;
	if(oCTF)
	{
		oCTF.aTopics=aTopics;
		ftsFindKeyword();
	}
}


function GetSearchText()
{
	var strLocation = document.location.href;
	var queryStartPos = strLocation.indexOf('%22');
	var queryEndPos = strLocation.lastIndexOf('%22');
	var strQuery = "";
	if(queryStartPos!=-1 && queryEndPos!=-1 )
	{
		strQuery = strLocation.substring(queryStartPos + 3  , queryEndPos);
	}
	strQuery= unescape(strQuery);
 	strQuery = strQuery.toLowerCase();
	return strQuery;
}

function window_OnLoad1()
{
	var bHidePane=false;
	if(gsProjName!="")			
		loadData2(gsProjName);	
}

function addProject(bPreferXML,sXMLName,sHTMLName)
{
	var bLoadXML=bPreferXML;
	bLoadXML=true;
	addProjectXML(sXMLName);
}

function putDataXMLProj(xmlDoc,sdocPath)
{
	gbProjectLoaded = true;
	if(xmlDoc!=null)
	{
		var projectNode=xmlDoc.getElementsByTagName("project")[0];
		if(projectNode)
		{
			var aRProj=new Array();
			aRProj[0]=new Object();
			aRProj[0].sPPath=_getPath(sdocPath);
			var sLangId=projectNode.getAttribute("langid");
			if(sLangId)
			{
				aRProj[0].sLangId=sLangId;
			}
			var sDPath=projectNode.getAttribute("datapath");
			if(sDPath)
			{
				if(sDPath.lastIndexOf("/")!=sDPath.length-1)
					sDPath+="/";
				aRProj[0].sDPath=sDPath;
			}
			else
				aRProj[0].sDPath="";
			aRProj[0].sToc=projectNode.getAttribute("toc");
			aRProj[0].sIdx=projectNode.getAttribute("index");
			aRProj[0].sFts=projectNode.getAttribute("fts");
			aRProj[0].sGlo=projectNode.getAttribute("glossary");
			var RmtProject=projectNode.getElementsByTagName("remote");
			var nCount=1;
			for (var i=0;i<RmtProject.length;i++)
			{
				var sURL=RmtProject[i].getAttribute("url");
				if(sURL)
				{
					if(sURL.lastIndexOf("/")!=sURL.length-1)
						sURL+="/";
					aRProj[nCount]=new Object();
					aRProj[nCount++].sPPath=_getFullPath(aRProj[0].sPPath,sURL);
				}
			}
			putProjectInfo(aRProj);
		}
		else
		{
			// on Netscape 6.0 under some situation the xml file cannot be loaded.
			// so we use pure html instead.
			if (gnChecked == 0)
				redirectToList();
			else
			{
				gnChecked++;
				checkRemoteProject();
			}
		}
	}
}

function checkRemoteProject()
{
	if(gaProj.length  != gnChecked)
	{
		var num = gnChecked;
		gbProjectLoaded = false;
		try
		{
			loadDataXML(gaProj[num].sPPath+gsProjName);
		}
		catch(er)
		{
			gbProjectLoaded = true;
		}
	}
	else gbReady=true;
	
}

function getTopics(oCF,sKey)
{
	var aTIPart=new Array();
	if(oCF&&oCF.aFtsKeys)
	{
		var keys=oCF.aFtsKeys;
		var nB=0;
		var nE=keys.length-1;
		var nM=-1;
		var bFound=false;
		do{
			nM=(nB+nE)>>1;
			if(compare(keys[nM].sItemName,sKey)>0)
				nE=nM-1;
			else if(compare(keys[nM].sItemName,sKey)<0)
				nB=nM+1;
			else{
				bFound=true;
				break;
			}
		}while(nB<=nE);
		if(bFound)
		{
			if(keys[nM].aTopics)
			{
				for(var i=0;i<keys[nM].aTopics.length;i++)
				{
					var oTC=getTopicChunk(gaaFTCD[oCF.nProjId],keys[nM].aTopics[i]);
					if(oTC.aTopics)
					{
						aTIPart[aTIPart.length]=
							new topicInfo(oTC.aTopics[keys[nM].aTopics[i]-oTC.nBegin].sTopicTitle,
								gaData[oCF.nProjId].sPPath+oTC.aTopics[keys[nM].aTopics[i]-oTC.nBegin].sTopicURL,
								oTC.aTopics[keys[nM].aTopics[i]-oTC.nBegin].sTopicContext);
					}
					else{
						goCTF=oTC;
						gnLoadFts=3;
						beginLoading();
						loadData2(gaData[oCF.nProjId].sPPath+gaData[oCF.nProjId].sDPath+oTC.sFileName);
						return null;
					}
				}
			}
		}
	}
	return aTIPart;
}
function topicInfo(sTopicTitle,sTopicURL,sTopicContext)
{
	this.sTopicTitle=sTopicTitle;
	this.sTopicURL=sTopicURL;
	this.sTopicContext=sTopicContext;
	this.equalTo=function(oTI)
	{
		return ((this.sTopicTitle==oTI.sTopicTitle)&&
			(this.sTopicURL==oTI.sTopicURL));
	}
}

